<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEventDatetimePair ArrayType
 * @subpackage Arrays
 */
class ArrayOfEventDatetimePair extends AbstractStructArrayBase
{
    /**
     * The EventDatetimePair
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\EventDatetimePair[]
     */
    public $EventDatetimePair;
    /**
     * Constructor method for ArrayOfEventDatetimePair
     * @uses ArrayOfEventDatetimePair::setEventDatetimePair()
     * @param \CustomerManagement\StructType\EventDatetimePair[] $eventDatetimePair
     */
    public function __construct(array $eventDatetimePair = array())
    {
        $this
            ->setEventDatetimePair($eventDatetimePair);
    }
    /**
     * Get EventDatetimePair value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\EventDatetimePair[]|null
     */
    public function getEventDatetimePair()
    {
        return isset($this->EventDatetimePair) ? $this->EventDatetimePair : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEventDatetimePair method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEventDatetimePair method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEventDatetimePairForArrayConstraintsFromSetEventDatetimePair(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEventDatetimePairEventDatetimePairItem) {
            // validation for constraint: itemType
            if (!$arrayOfEventDatetimePairEventDatetimePairItem instanceof \CustomerManagement\StructType\EventDatetimePair) {
                $invalidValues[] = is_object($arrayOfEventDatetimePairEventDatetimePairItem) ? get_class($arrayOfEventDatetimePairEventDatetimePairItem) : sprintf('%s(%s)', gettype($arrayOfEventDatetimePairEventDatetimePairItem), var_export($arrayOfEventDatetimePairEventDatetimePairItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EventDatetimePair property can only contain items of type \CustomerManagement\StructType\EventDatetimePair, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EventDatetimePair value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\EventDatetimePair[] $eventDatetimePair
     * @return \CustomerManagement\ArrayType\ArrayOfEventDatetimePair
     */
    public function setEventDatetimePair(array $eventDatetimePair = array())
    {
        // validation for constraint: array
        if ('' !== ($eventDatetimePairArrayErrorMessage = self::validateEventDatetimePairForArrayConstraintsFromSetEventDatetimePair($eventDatetimePair))) {
            throw new \InvalidArgumentException($eventDatetimePairArrayErrorMessage, __LINE__);
        }
        if (is_null($eventDatetimePair) || (is_array($eventDatetimePair) && empty($eventDatetimePair))) {
            unset($this->EventDatetimePair);
        } else {
            $this->EventDatetimePair = $eventDatetimePair;
        }
        return $this;
    }
    /**
     * Add item to EventDatetimePair value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\EventDatetimePair $item
     * @return \CustomerManagement\ArrayType\ArrayOfEventDatetimePair
     */
    public function addToEventDatetimePair(\CustomerManagement\StructType\EventDatetimePair $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\EventDatetimePair) {
            throw new \InvalidArgumentException(sprintf('The EventDatetimePair property can only contain items of type \CustomerManagement\StructType\EventDatetimePair, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EventDatetimePair[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\EventDatetimePair|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\EventDatetimePair|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\EventDatetimePair|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\EventDatetimePair|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\EventDatetimePair|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EventDatetimePair
     */
    public function getAttributeName()
    {
        return 'EventDatetimePair';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfEventDatetimePair
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
